#!/usr/local/bin/perl

$BASE_DIR = "users/";

$QueryString = $ENV{QUERY_STRING};

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

$user = $ENV{"REMOTE_USER"};
$BASE_DIR = "${BASE_DIR}${user}/";

$output = `cd \"$BASE_DIR$Form{path}\"; find * -maxdepth 0 -type d -print`;

if ($output ne "") {
  print "Content-type: text/html", "\n\n";
  print "<html><body>";
  print "<B>ERROR</B><BR>Delete all categories under this category before deleting it.";
  exit(0);
}

# Split the path for the current category
@category_list = split (/\//, $Form{path});

# Read the global config file into Config_global
&parse_config_file ("$BASE_DIR$category_list[0].config", \%Config_global);

# Read the local config file into Config_local
&parse_config_file ("$BASE_DIR$Form{path}\/config", \%Config_local);

dbmopen %ENTRIES, "$BASE_DIR$Form{path}\/entries", 0666;

if ($ENTRIES{"LARGEST_KEY"} ne "") {
  print "Content-type: text/html", "\n\n";
  print "<html><body>";
  print "<B>ERROR</B><BR>Delete all entries under this category before deleting it.";
  exit(0);
}

dbmclose %ENTRIES;

# Lock the category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &lock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to lock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to lock the category $Form{path}.";
    exit(0);
  }

$output = `rm \"$BASE_DIR$Form{path}\/config\"`;
$output = `rm \"$BASE_DIR$Form{path}\/entries.dir\"`;
$output = `rm \"$BASE_DIR$Form{path}\/entries.pag\"`;
$output = `rm \"$BASE_DIR$Form{path}\/lock\"`;

$output = `rmdir \"$BASE_DIR$Form{path}\"`;

$len_category_list = -1;
foreach $category (@category_list) {
  $len_category_list++;
}

$previous_category_path = "$category_list[0]";
for ($i = 1; $i < $len_category_list; $i++) {
  $previous_category_path = "$previous_category_path\/$category_list[$i]";
}

$the_path = $previous_category_path;
$the_path =~ tr/ /+/;
print "Location: display.pl?path=$the_path", "\n\n";


# Subroutine to unlock the category
sub unlock {

  ($_) = @_;

  $output = `rm \"$_\/lock\"`;
  if (open(LOCK, "$_\/lock")) {
    close(LOCK);
    return 0;
  }

  return 1;
}

# Subroutine to lock the category
sub lock {

  ($_) = @_;

  if (open(LOCK, "$_\/lock")) {
    $time_of_lock = <LOCK>;
    $time = time();
    if ($time - $time_of_lock < 900) {
      close(LOCK);
      return 0;
    }
    close(LOCK);
  }

  open(LOCK, ">$_\/lock");

  $time = time();
  print LOCK "$time";

  close(LOCK);

  return 1;

}

#subroutine to parse a config file and store it as a hash.
#Takes 2 arguments - the config file and a reference to the hash

sub parse_config_file {

local ($config_line, $Name, $Value, $Config);

$Config = $_[1];

if (!open (CONFIG, "$_[0]")) {
  print "<B>ERROR</B><BR>Config file not found : $_[0]";
  exit(0);
}

while (<CONFIG>) {
    $config_line=$_;
    chop ($config_line);
    $config_line =~ s/^\s*//;
    $config_line =~ s/\s*$//;
    if ( ($config_line !~ /^#/) && ($config_line ne "") ){
        ($Name, $Value) = split (/=/, $config_line);
        $$Config{$Name} = $Value;
    }
}

close(CONFIG);

}





