#!/usr/local/bin/perl

$BASE_DIR = "users/";
$BASE_DIR_CACHE = "/home/motreja/www/ankur/webdrill/cache/";
$BASE_DIR_SAVED = "/home/motreja/www/ankur/webdrill/saved/";

$QueryString = $ENV{QUERY_STRING};

@NameValuePairs = split (/&/, $QueryString);

foreach $NameValue (@NameValuePairs) {
  ($Name, $Value) = split (/=/, $NameValue);
  $Value =~ tr/+/ /;
  $Value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/eg;
  $Form{$Name} = $Value;
}

$user = $ENV{"REMOTE_USER"};
$BASE_DIR = "${BASE_DIR}${user}/";
$BASE_CACHE_USER = "${BASE_DIR_CACHE}${user}/";
$BASE_SAVED_USER = "${BASE_DIR_SAVED}${user}/";

# Split the path for the current category
@category_list = split (/\//, $Form{path});

# Read the global config file into Config_global
&parse_config_file ("$BASE_DIR$category_list[0].config", \%Config_global);

# Read the local config file into Config_local
&parse_config_file ("$BASE_DIR$Form{path}\/config", \%Config_local);

# Lock the category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &lock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to lock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to lock the category $Form{path}.";
    exit(0);
  }

dbmopen %ENTRIES, "$BASE_DIR$Form{path}\/entries", 0666;

$rec_no = $Form{"entry_no"};
$rec_name = $ENTRIES{"${rec_no}_name"};

$i = $Form{"entry_no"};
$j = 0;
while ($Config_global{"${j}_key"} ne "") {
    $key = $Config_global{"${j}_key"};
    delete $ENTRIES{"${i}_$key"};
    $j++;
}

delete $ENTRIES{"${i}_USED"};

if ( $i == $ENTRIES{"LARGEST_KEY"} ) {
  $current_largest_key = -1;
  for ( $j = 0; $j <= $i; $j++) {
      if ($ENTRIES{"${j}_USED"} == 1) {
          $current_largest_key = $j;
      }
  }

  if ( $current_largest_key == -1 ) {
      delete $ENTRIES{"LARGEST_KEY"};
  } else {
      $ENTRIES{"LARGEST_KEY"} = $current_largest_key;
  }
}

dbmclose %ENTRIES;

# Unlock the category
  $i = 0;
  while ($i < 5) {
    $i++;
    $result = &unlock("$BASE_DIR$Form{path}");
    if ($result == 1) {
      $i = 5;
    } else {
      sleep(3);
    }
  }

# Just in case something went wrong and we were unable to unlock the category
  if ($result == 0) {
    print "Content-type: text/html", "\n\n";
    print "<html><body>";
    print "<B>ERROR</B><BR>Unable to unlock the category $Form{path}.";
    exit(0);
  }

`rm ${BASE_CACHE_USER}${rec_name}.htm`;
`rm ${BASE_SAVED_USER}${rec_name}.htm`;

$the_path = $Form{path};
$the_path =~ tr/ /+/;
print "Location: display.pl?path=$the_path", "\n\n";


#subroutine to parse a config file and store it as a hash.
#Takes 2 arguments - the config file and a reference to the hash

sub parse_config_file {

local ($config_line, $Name, $Value, $Config);

$Config = $_[1];

if (!open (CONFIG, "$_[0]")) {
  print "Content-type: text/html", "\n\n";
  print "<html><body>";
  print "<B>ERROR</B><BR>Config file not found : $_[0]";
  exit(0);
}

while (<CONFIG>) {
    $config_line=$_;
    chop ($config_line);
    $config_line =~ s/^\s*//;
    $config_line =~ s/\s*$//;
    if ( ($config_line !~ /^#/) && ($config_line ne "") ){
        ($Name, $Value) = split (/=/, $config_line);
        $$Config{$Name} = $Value;
    }
}

close(CONFIG);

}


# Subroutine to lock the category
sub lock {

  ($_) = @_;

  if (open(LOCK, "$_\/lock")) {
    $time_of_lock = <LOCK>;
    $time = time();
    if ($time - $time_of_lock < 900) {
      close(LOCK);
      return 0;
    }
    close(LOCK);
  }

  open(LOCK, ">$_\/lock");

  $time = time();
  print LOCK "$time";

  close(LOCK);

  return 1;

}


# Subroutine to unlock the category
sub unlock {

  ($_) = @_;

  $output = `rm \"$_\/lock\"`;
  if (open(LOCK, "$_\/lock")) {
    close(LOCK);
    return 0;
  }

  return 1;
}


